#### Beyond Linux® From Scratch (systemd Edition) - Version r13.0-491

### Chapter 26. Display Managers

- Prev

  Display Managers

- Next

  lightdm-1.32.0

- Up
- Home

# GDM-50.0

## Introduction to GDM

GDM is a system service that is responsible for providing graphical logins and managing local and remote displays.

### Note

Development versions of BLFS may not build or run some packages properly if LFS or dependencies have been updated since the most recent stable versions of the books.

### Package Information

- Download (HTTP): https://download.gnome.org/sources/gdm/50/gdm-50.0.tar.xz

- Download MD5 sum: 0b7d472c4a38f69cdd6dd1f3a05ede65

- Download size: 933 KB

- Estimated disk space required: 35 MB

- Estimated build time: less than 0.1 SBU

### GDM Dependencies

#### Required

AccountsService-23.13.9, DConf-0.49.0, libcanberra-0.30 (built after GTK-3.24.52), and Linux-PAM-1.7.2

#### Optional

keyutils-1.6.3 and check (for testing)

#### Runtime Dependencies

gnome-session-50.0, gnome-shell-50.1, and Systemd-260.1

## Installation of GDM

GDM needs to start as `root`, but quickly drops privileges to dynamic users created with userdb. We only need to create a dedicated group for those users. Issue the following command as the `root` user:

    groupadd -g 21 gdm

Install GDM by running the following commands:

    mkdir build &&
    cd    build &&

    meson setup ..             \
          --prefix=/usr        \
          --buildtype=release  \
          -D gdm-xsession=true \
          -D run-dir=/run/gdm  &&
    ninja

The test suite requires Check that is not available.

Now, as the `root` user:

    ninja install

## Command Explanations

`--buildtype=release`: Specify a buildtype suitable for stable releases of the package, as the default may produce unoptimized binaries.

`-D default-pam-config=lfs`: Use this switch if you did not create the `/etc/lfs-release` file or distribution auto detection will fail and you will be unable to use GDM.

`-D gdm-xsession=true`: This enables the installation of the GDM Xsession file.

## Configuring GDM

### Config Files

`/etc/gdm/custom.conf`

### Configuration Information

The GDM daemon is configured using the `/etc/gdm/custom.conf` file. Default values are stored in GSettings in the `gdm.schemas` file. It is recommended that end-users modify the `/etc/gdm/custom.conf` file because the schemas file may be overwritten when the user updates their system to have a newer version of GDM.

On some systems with NVIDIA GPUs or virtual GPUs (such as provided by qemu), GDM will hide Wayland sessions by default. This is often done to prevent users from encountering problems with buggy drivers, which can result in system lockups, application crashes, power management problems, and graphics slowdowns. If your system is a virtual machine or you have an NVIDIA GPU and still want to try running Wayland sessions anyway, execute the following command as the `root` user:

    ln -s /dev/null /etc/udev/rules.d/61-gdm.rules

### Systemd Unit

To start the gdm daemon at boot, enable the previously installed systemd unit by running the following command as the `root` user:

    systemctl enable gdm

### Configuring GDM Auto-Suspend

GDM will suspend the system when the greeter screen has been running for a while without any interactive input. If you want to disable auto-suspending for any reason (for example if the system is hosting some services besides functioning as a desktop system), as the `root` user, issue:

    su gdm -s /bin/bash                                                \
           -c "dbus-run-session                                        \
                 gsettings set org.gnome.settings-daemon.plugins.power \
                               sleep-inactive-ac-type                  \
                               nothing"

## Contents

Installed Programs: gdm and gdm-config
Installed Libraries: libgdm.so and pam_gdm.so (PAM Module)
Installed Directories: /etc/gdm, /usr/include/gdm, /usr/share/gdm, and /usr/share/help/*/gdm

### Short Descriptions

gdm | is a login prompt for GNOME
gdm-config | configures a variety of authentication options for GDM

- Prev

  Display Managers

- Next

  lightdm-1.32.0

- Up
- Home